Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 61801)
+++ channels/chan_sip.c	(working copy)
@@ -1316,7 +1316,7 @@
 static enum check_auth_result register_verify(struct sip_pvt *p, struct sockaddr_in *sin,
 					      struct sip_request *req, char *uri);
 static struct sip_pvt *get_sip_pvt_byid_locked(const char *callid, const char *totag, const char *fromtag);
-static void check_pendings(struct sip_pvt *p);
+static void check_pendings(struct sip_pvt *p, int check_reinvite);
 static void *sip_park_thread(void *stuff);
 static int sip_park(struct ast_channel *chan1, struct ast_channel *chan2, struct sip_request *req, int seqno);
 static int sip_sipredirect(struct sip_pvt *p, const char *dest);
@@ -12317,7 +12317,7 @@
 }
 
 /*! \brief Check pending actions on SIP call */
-static void check_pendings(struct sip_pvt *p)
+static void check_pendings(struct sip_pvt *p, int check_reinvite)
 {
 	if (ast_test_flag(&p->flags[0], SIP_PENDINGBYE)) {
 		/* if we can't BYE, then this is really a pending CANCEL */
@@ -12329,7 +12329,7 @@
 			transmit_request_with_auth(p, SIP_BYE, 0, XMIT_RELIABLE, TRUE);
 		ast_clear_flag(&p->flags[0], SIP_PENDINGBYE);	
 		sip_scheddestroy(p, DEFAULT_TRANS_TIMEOUT);
-	} else if (ast_test_flag(&p->flags[0], SIP_NEEDREINVITE)) {
+	} else if( check_reinvite != FALSE && ast_test_flag(&p->flags[0], SIP_NEEDREINVITE)) {
 		if (option_debug)
 			ast_log(LOG_DEBUG, "Sending pending reinvite on '%s'\n", p->callid);
 		/* Didn't get to reinvite yet, so do it now */
@@ -12386,7 +12386,7 @@
 	case 101:	/* Dialog establishment */
 		if (!ast_test_flag(req, SIP_PKT_IGNORE))
 			sip_cancel_destroy(p);
-		check_pendings(p);
+		check_pendings(p, FALSE);
 		break;
 
 	case 180:	/* 180 Ringing */
@@ -12406,7 +12406,7 @@
 				ast_queue_control(p->owner, AST_CONTROL_PROGRESS);
 			}
 		}
-		check_pendings(p);
+		check_pendings(p, FALSE);
 		break;
 
 	case 183:	/* Session progress */
@@ -12421,7 +12421,7 @@
 				ast_queue_control(p->owner, AST_CONTROL_PROGRESS);
 			}
 		}
-		check_pendings(p);
+		check_pendings(p, FALSE);
 		break;
 
 	case 200:	/* 200 OK on invite - someone's answering our call */
@@ -12523,7 +12523,7 @@
 		/* If I understand this right, the branch is different for a non-200 ACK only */
 		p->invitestate = INV_TERMINATED;
 		transmit_request(p, SIP_ACK, seqno, XMIT_UNRELIABLE, TRUE);
-		check_pendings(p);
+		check_pendings(p, TRUE);
 		break;
 
 	case 407: /* Proxy authentication */
@@ -15527,7 +15527,7 @@
 				if (process_sdp(p, req))
 					return -1;
 			} 
-			check_pendings(p);
+			check_pendings(p, TRUE);
 		}
 		/* Got an ACK that we did not match. Ignore silently */
 		if (!p->lastinvite && ast_strlen_zero(p->randdata))
